(* Title:  "BaseDefinitions/check-unique.sml"
   Author: Walther Neuper
   (c) due to copyright terms
*)

"-----------------------------------------------------------------------------------------------";
"table of contents -----------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"----------- re-build check_pblguh_unique with high order funs ---------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";
"-----------------------------------------------------------------------------------------------";


"----------- re-build check_pblguh_unique with high order funs ---------------------------------";
"----------- re-build check_pblguh_unique with high order funs ---------------------------------";
"----------- re-build check_pblguh_unique with high order funs ---------------------------------";
(*------- auxiliary format for fn*)
fun pbl_select_guh pbt =
  let                                          
    val {guh, ...} = (**)(pbt: Problem.T)(** )(pbt: met)( **)
  in guh end;
pbl_select_guh: Problem.T -> Check_Unique.id;(**)

fun met_select_guh pbt =
  let                                          
    val {guh, ...} = (pbt: MethodC.T)
  in guh end;
met_select_guh: MethodC.T -> Check_Unique.id;(**)

(*------- hint: build higher order functions be replacing the selector by a variable argument *)
(*  collect*)
fun collect select_guh pbls =
  let
    fun node coll (Store.Node (_, [n], ns)) = [select_guh n] @ (nodes coll ns)
      | node _ _ = raise ERROR "collect_guhs: too general Store.Node"
	  and nodes coll [] = coll
      | nodes coll (n :: ns) = (node coll n) @ (nodes coll ns);
  in nodes [] pbls end;

collect: ('a -> 'b) -> 'a   Store.T -> 'b list;
collect pbl_select_guh: Problem.T Store.T -> Check_Unique.id list;
collect met_select_guh: MethodC.T Store.T -> Check_Unique.id list;

fun message select store guh =
  if member op = (select store) guh
  then error ("Check_Unique failed with \"" ^ guh ^ "\";\n" ^
	      "use \"sort_guhs()\" for a list of guhs;\n" ^
	      "consider setting \"Check_Unique.on := false\"")
  else ();

 message: ('a -> Check_Unique.id list       ) -> 'a           -> Check_Unique.id -> unit;
(message (collect pbl_select_guh)): Problem.T Store.T -> Check_Unique.id -> unit;
(message (collect met_select_guh)): MethodC.T Store.T -> Check_Unique.id -> unit;

(Check_Unique.collect (#guh : Probl_Def.T -> Check_Unique.id)): Problem.T Store.T -> Check_Unique.id list;
(Check_Unique.collect (#guh : Meth_Def.T -> Check_Unique.id)): MethodC.T Store.T -> Check_Unique.id list;

val check_pblguh_unique = message (Check_Unique.collect (#guh : Probl_Def.T -> Check_Unique.id));
check_pblguh_unique: Problem.T Store.T -> Check_Unique.id -> unit
;
val check_metguh_unique = message (Check_Unique.collect (#guh : Meth_Def.T -> Check_Unique.id));
check_metguh_unique: Meth_Def.T Store.T -> Check_Unique.id -> unit
;